# Xapian::Compactor Class Reference

Compact a database, or merge and compact several. More...

List of all members.

## Public Member Functions

void | set_block_size (size_t block_size)
| Set the block size to use for tables in the output database.
void | set_renumber (bool renumber)
| Set whether to preserve existing document id values.
void | set_multipass (bool multipass)
| Set whether to merge postlists in multiple passes.
void | set_compaction_level (compaction_level compaction)
| Set the compaction level.
void | set_destdir (const std::string &destdir)
| Set where to write the output.
void | add_source (const std::string &srcdir)
| Add a source database.
void | compact ()
| Perform the actual compaction/merging operation.
virtual void | set_status (const std::string &table, const std::string &status)
| Update progress.
virtual std::string | resolve_duplicate_metadata (const std::string &key, size_t num_tags, const std::string tags[])
| Resolve multiple user metadata entries with the same key.

## Detailed Description

Compact a database, or merge and compact several.

## Member Function Documentation

void Xapian::Compactor::add_source | ( | const std::string & | srcdir | ) |

Add a source database.

Parameters:

  | srcdir | The path to the source database to add.

virtual std::string Xapian::Compactor::resolve_duplicate_metadata | ( | const std::string & | key,
|  | size_t | num_tags,
|  | const std::string | tags[] |
| ) |  |  | `[virtual]`

Resolve multiple user metadata entries with the same key.

When merging, if the same user metadata key is set in more than one input, then this method is called to allow this to be resolving in an appropriate way.

The default implementation just returns tags[0].

For multipass this will currently get called multiple times for the same key if there are duplicates to resolve in each pass, but this may change in the future.

Parameters:

  | key | The metadata key with duplicate entries.
  | num_tags | How many tags there are.
  | tags | An array of num_tags strings containing the tags to merge.

void Xapian::Compactor::set_block_size | ( | size_t | block_size | ) |

Set the block size to use for tables in the output database.

Parameters:

  | block_size | The block size to use. Valid block sizes are currently powers of two between 2048 and 65536, with the default being 8192, but the valid sizes and default may change in the future.

void Xapian::Compactor::set_compaction_level | ( | compaction_level | compaction | ) |

Set the compaction level.

Parameters:

  | compaction | Available values are: - Xapian::Compactor::STANDARD - Don't split items unnecessarily. - Xapian::Compactor::FULL - Split items whenever it saves space (the default). - Xapian::Compactor::FULLER - Allow oversize items to save more space (not recommended if you ever plan to update the compacted database).

void Xapian::Compactor::set_destdir | ( | const std::string & | destdir | ) |

Set where to write the output.

Parameters:

  | destdir | Output path. This can be the same as an input if that input is a stub database (in which case the database(s) listed in the stub will be compacted to a new database and then the stub will be atomically updated to point to this new database).

void Xapian::Compactor::set_multipass | ( | bool | multipass | ) |

Set whether to merge postlists in multiple passes.

Parameters:

  | multipass | If true and merging more than 3 databases, merge the postlists in multiple passes, which is generally faster but requires more disk space for temporary files. By default we don't do this.

void Xapian::Compactor::set_renumber | ( | bool | renumber | ) |

Set whether to preserve existing document id values.

Parameters:

  | renumber | The default is true, which means that document ids will be renumbered - currently by applying the same offset to all the document ids in a particular source database.

If false, then the document ids must be unique over all source databases. Currently the ranges of document ids in each source must not overlap either, though this restriction may be removed in the future.

virtual void Xapian::Compactor::set_status | ( | const std::string & | table,
|  | const std::string & | status |
| ) |  |  | `[virtual]`

Update progress.

Subclass this method if you want to get progress updates during compaction. This is called for each table first with empty status, And then one or more times with non-empty status.

The default implementation does nothing.

Parameters:

  | table | The table currently being compacted.
  | status | A status message.

The documentation for this class was generated from the following file:

- xapian/compactor.h